/* Utils.c generated by valac 0.54.8, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2015-2021 Sam Thomas
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <errno.h>

#define HOURGLASS_UTILS_ALARM_INFO_SEPARATOR ";"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HOURGLASS_UTILS_TYPE_TIME (hourglass_utils_time_get_type ())
typedef struct _HourglassUtilsTime HourglassUtilsTime;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HourglassUtilsTime {
	gint64 hours;
	gint64 minutes;
	gint64 seconds;
	gint64 milliseconds;
};

VALA_EXTERN GType hourglass_utils_time_get_type (void) G_GNUC_CONST ;
VALA_EXTERN HourglassUtilsTime* hourglass_utils_time_dup (const HourglassUtilsTime* self);
VALA_EXTERN void hourglass_utils_time_free (HourglassUtilsTime* self);
VALA_EXTERN void hourglass_utils_parse_milliseconds (gint64 milliseconds,
                                         HourglassUtilsTime* result);
VALA_EXTERN gchar* hourglass_utils_get_formatted_time (gint64 milliseconds,
                                           gboolean with_millisecond);
VALA_EXTERN gboolean hourglass_utils_is_valid_alarm_string (const gchar* alarm_string);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

HourglassUtilsTime*
hourglass_utils_time_dup (const HourglassUtilsTime* self)
{
	HourglassUtilsTime* dup;
	dup = g_new0 (HourglassUtilsTime, 1);
	memcpy (dup, self, sizeof (HourglassUtilsTime));
	return dup;
}

void
hourglass_utils_time_free (HourglassUtilsTime* self)
{
	g_free (self);
}

static GType
hourglass_utils_time_get_type_once (void)
{
	GType hourglass_utils_time_type_id;
	hourglass_utils_time_type_id = g_boxed_type_register_static ("HourglassUtilsTime", (GBoxedCopyFunc) hourglass_utils_time_dup, (GBoxedFreeFunc) hourglass_utils_time_free);
	return hourglass_utils_time_type_id;
}

GType
hourglass_utils_time_get_type (void)
{
	static volatile gsize hourglass_utils_time_type_id__volatile = 0;
	if (g_once_init_enter (&hourglass_utils_time_type_id__volatile)) {
		GType hourglass_utils_time_type_id;
		hourglass_utils_time_type_id = hourglass_utils_time_get_type_once ();
		g_once_init_leave (&hourglass_utils_time_type_id__volatile, hourglass_utils_time_type_id);
	}
	return hourglass_utils_time_type_id__volatile;
}

void
hourglass_utils_parse_milliseconds (gint64 milliseconds,
                                    HourglassUtilsTime* result)
{
	HourglassUtilsTime time = {0};
	memset (&time, 0, sizeof (HourglassUtilsTime));
	time.hours = milliseconds / ((gint64) G_TIME_SPAN_HOUR);
	milliseconds = milliseconds % ((gint64) G_TIME_SPAN_HOUR);
	time.minutes = milliseconds / ((gint64) G_TIME_SPAN_MINUTE);
	milliseconds = milliseconds % ((gint64) G_TIME_SPAN_MINUTE);
	time.seconds = milliseconds / ((gint64) G_TIME_SPAN_SECOND);
	milliseconds = milliseconds % ((gint64) G_TIME_SPAN_SECOND);
	time.milliseconds = milliseconds % (((gint64) G_TIME_SPAN_MILLISECOND) / 10);
	*result = time;
	return;
}

gchar*
hourglass_utils_get_formatted_time (gint64 milliseconds,
                                    gboolean with_millisecond)
{
	HourglassUtilsTime time = {0};
	HourglassUtilsTime _tmp0_ = {0};
	gchar* result = NULL;
	hourglass_utils_parse_milliseconds (milliseconds, &_tmp0_);
	time = _tmp0_;
	if (with_millisecond) {
		HourglassUtilsTime _tmp1_;
		HourglassUtilsTime _tmp6_;
		HourglassUtilsTime _tmp7_;
		HourglassUtilsTime _tmp8_;
		HourglassUtilsTime _tmp9_;
		gchar* _tmp10_;
		_tmp1_ = time;
		if (_tmp1_.hours == ((gint64) 0)) {
			HourglassUtilsTime _tmp2_;
			HourglassUtilsTime _tmp3_;
			HourglassUtilsTime _tmp4_;
			gchar* _tmp5_;
			_tmp2_ = time;
			_tmp3_ = time;
			_tmp4_ = time;
			_tmp5_ = g_strdup_printf ("%02llu:%02llu:%02llu", _tmp2_.minutes, _tmp3_.seconds, _tmp4_.milliseconds);
			result = _tmp5_;
			return result;
		}
		_tmp6_ = time;
		_tmp7_ = time;
		_tmp8_ = time;
		_tmp9_ = time;
		_tmp10_ = g_strdup_printf ("%02llu:%02llu:%02llu:%02llu", _tmp6_.hours, _tmp7_.minutes, _tmp8_.seconds, _tmp9_.milliseconds);
		result = _tmp10_;
		return result;
	} else {
		HourglassUtilsTime _tmp11_;
		HourglassUtilsTime _tmp15_;
		HourglassUtilsTime _tmp16_;
		HourglassUtilsTime _tmp17_;
		gchar* _tmp18_;
		_tmp11_ = time;
		if (_tmp11_.hours == ((gint64) 0)) {
			HourglassUtilsTime _tmp12_;
			HourglassUtilsTime _tmp13_;
			gchar* _tmp14_;
			_tmp12_ = time;
			_tmp13_ = time;
			_tmp14_ = g_strdup_printf ("%02llu:%02llu", _tmp12_.minutes, _tmp13_.seconds);
			result = _tmp14_;
			return result;
		}
		_tmp15_ = time;
		_tmp16_ = time;
		_tmp17_ = time;
		_tmp18_ = g_strdup_printf ("%02llu:%02llu:%02llu", _tmp15_.hours, _tmp16_.minutes, _tmp17_.seconds);
		result = _tmp18_;
		return result;
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar** unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (str != NULL, FALSE);
	errno = 0;
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
	endptr = _tmp0_;
	_vala__result_ = _tmp1_;
	_tmp2_ = endptr;
	_tmp3_ = strlen (str);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
		gboolean _tmp5_ = FALSE;
		_vala_unparsed = "";
		if (errno != ERANGE) {
			_tmp5_ = errno != EINVAL;
		} else {
			_tmp5_ = FALSE;
		}
		result = _tmp5_;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	} else {
		gchar* _tmp6_;
		_tmp6_ = endptr;
		_vala_unparsed = (const gchar*) _tmp6_;
		result = FALSE;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	}
}

gboolean
hourglass_utils_is_valid_alarm_string (const gchar* alarm_string)
{
	gboolean result = FALSE;
	g_return_val_if_fail (alarm_string != NULL, FALSE);
	if (string_contains (alarm_string, HOURGLASS_UTILS_ALARM_INFO_SEPARATOR)) {
		gchar** parts = NULL;
		gchar** _tmp0_;
		gchar** _tmp1_;
		gint parts_length1;
		gint _parts_size_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** time_string_parts = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gint time_string_parts_length1;
		gint _time_string_parts_size_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		gchar** _tmp23_;
		gint _tmp23__length1;
		const gchar* _tmp24_;
		gchar** _tmp34_;
		gint _tmp34__length1;
		const gchar* _tmp35_;
		_tmp1_ = _tmp0_ = g_strsplit (alarm_string, HOURGLASS_UTILS_ALARM_INFO_SEPARATOR, 0);
		parts = _tmp1_;
		parts_length1 = _vala_array_length (_tmp0_);
		_parts_size_ = parts_length1;
		_tmp2_ = parts;
		_tmp2__length1 = parts_length1;
		if (_tmp2__length1 != 6) {
			result = FALSE;
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
		_tmp3_ = parts;
		_tmp3__length1 = parts_length1;
		_tmp4_ = _tmp3_[1];
		_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ",", 0);
		time_string_parts = _tmp6_;
		time_string_parts_length1 = _vala_array_length (_tmp5_);
		_time_string_parts_size_ = time_string_parts_length1;
		_tmp7_ = time_string_parts;
		_tmp7__length1 = time_string_parts_length1;
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
			s_collection = _tmp7_;
			s_collection_length1 = _tmp7__length1;
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
				gchar* _tmp8_;
				gchar* s = NULL;
				_tmp8_ = g_strdup (s_collection[s_it]);
				s = _tmp8_;
				{
					gint64 i = 0LL;
					const gchar* _tmp9_;
					gint64 _tmp10_ = 0LL;
					gboolean _tmp11_;
					i = (gint64) 0;
					_tmp9_ = s;
					_tmp11_ = int64_try_parse (_tmp9_, &_tmp10_, NULL, (guint) 0);
					i = _tmp10_;
					if (!_tmp11_) {
						result = FALSE;
						_g_free0 (s);
						time_string_parts = (_vala_array_free (time_string_parts, time_string_parts_length1, (GDestroyNotify) g_free), NULL);
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						return result;
					}
					_g_free0 (s);
				}
			}
		}
		_tmp12_ = parts;
		_tmp12__length1 = parts_length1;
		_tmp13_ = _tmp12_[2];
		if (g_strcmp0 (_tmp13_, "none") != 0) {
			gchar** date_string_parts = NULL;
			gchar** _tmp14_;
			gint _tmp14__length1;
			const gchar* _tmp15_;
			gchar** _tmp16_;
			gchar** _tmp17_;
			gint date_string_parts_length1;
			gint _date_string_parts_size_;
			gchar** _tmp18_;
			gint _tmp18__length1;
			_tmp14_ = parts;
			_tmp14__length1 = parts_length1;
			_tmp15_ = _tmp14_[2];
			_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "-", 0);
			date_string_parts = _tmp17_;
			date_string_parts_length1 = _vala_array_length (_tmp16_);
			_date_string_parts_size_ = date_string_parts_length1;
			_tmp18_ = date_string_parts;
			_tmp18__length1 = date_string_parts_length1;
			{
				gchar** s_collection = NULL;
				gint s_collection_length1 = 0;
				gint _s_collection_size_ = 0;
				gint s_it = 0;
				s_collection = _tmp18_;
				s_collection_length1 = _tmp18__length1;
				for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
					gchar* _tmp19_;
					gchar* s = NULL;
					_tmp19_ = g_strdup (s_collection[s_it]);
					s = _tmp19_;
					{
						gint64 i = 0LL;
						const gchar* _tmp20_;
						gint64 _tmp21_ = 0LL;
						gboolean _tmp22_;
						i = (gint64) 0;
						_tmp20_ = s;
						_tmp22_ = int64_try_parse (_tmp20_, &_tmp21_, NULL, (guint) 0);
						i = _tmp21_;
						if (!_tmp22_) {
							result = FALSE;
							_g_free0 (s);
							date_string_parts = (_vala_array_free (date_string_parts, date_string_parts_length1, (GDestroyNotify) g_free), NULL);
							time_string_parts = (_vala_array_free (time_string_parts, time_string_parts_length1, (GDestroyNotify) g_free), NULL);
							parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
							return result;
						}
						_g_free0 (s);
					}
				}
			}
			date_string_parts = (_vala_array_free (date_string_parts, date_string_parts_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp23_ = parts;
		_tmp23__length1 = parts_length1;
		_tmp24_ = _tmp23_[3];
		if (g_strcmp0 (_tmp24_, "none") != 0) {
			gchar** repeat_string_parts = NULL;
			gchar** _tmp25_;
			gint _tmp25__length1;
			const gchar* _tmp26_;
			gchar** _tmp27_;
			gchar** _tmp28_;
			gint repeat_string_parts_length1;
			gint _repeat_string_parts_size_;
			gchar** _tmp29_;
			gint _tmp29__length1;
			_tmp25_ = parts;
			_tmp25__length1 = parts_length1;
			_tmp26_ = _tmp25_[3];
			_tmp28_ = _tmp27_ = g_strsplit (_tmp26_, ",", 0);
			repeat_string_parts = _tmp28_;
			repeat_string_parts_length1 = _vala_array_length (_tmp27_);
			_repeat_string_parts_size_ = repeat_string_parts_length1;
			_tmp29_ = repeat_string_parts;
			_tmp29__length1 = repeat_string_parts_length1;
			{
				gchar** s_collection = NULL;
				gint s_collection_length1 = 0;
				gint _s_collection_size_ = 0;
				gint s_it = 0;
				s_collection = _tmp29_;
				s_collection_length1 = _tmp29__length1;
				for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
					gchar* _tmp30_;
					gchar* s = NULL;
					_tmp30_ = g_strdup (s_collection[s_it]);
					s = _tmp30_;
					{
						gint64 i = 0LL;
						const gchar* _tmp31_;
						gint64 _tmp32_ = 0LL;
						gboolean _tmp33_;
						i = (gint64) 0;
						_tmp31_ = s;
						_tmp33_ = int64_try_parse (_tmp31_, &_tmp32_, NULL, (guint) 0);
						i = _tmp32_;
						if (!_tmp33_) {
							result = FALSE;
							_g_free0 (s);
							repeat_string_parts = (_vala_array_free (repeat_string_parts, repeat_string_parts_length1, (GDestroyNotify) g_free), NULL);
							time_string_parts = (_vala_array_free (time_string_parts, time_string_parts_length1, (GDestroyNotify) g_free), NULL);
							parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
							return result;
						}
						_g_free0 (s);
					}
				}
			}
			repeat_string_parts = (_vala_array_free (repeat_string_parts, repeat_string_parts_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp34_ = parts;
		_tmp34__length1 = parts_length1;
		_tmp35_ = _tmp34_[4];
		if (!string_contains ("on off", _tmp35_)) {
			result = FALSE;
			time_string_parts = (_vala_array_free (time_string_parts, time_string_parts_length1, (GDestroyNotify) g_free), NULL);
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
		result = TRUE;
		time_string_parts = (_vala_array_free (time_string_parts, time_string_parts_length1, (GDestroyNotify) g_free), NULL);
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

